import 'app_localizations.dart';

/// The translations for English (`en`).
class AppLocalizationsEn extends AppLocalizations {
  AppLocalizationsEn([String locale = 'en']) : super(locale);

  @override
  String get appTitle => 'noefinderlein_flutter';

  @override
  String get stifte => 'Stifte';

  @override
  String get burgen_schloesser => 'Castles and palaces';

  @override
  String get museen_ausstellungen => 'Museums and exhibitions';

  @override
  String get erlebnis_natur => 'Nature and experiences';

  @override
  String get sport_und_freizeit => 'Sport and leisure';

  @override
  String get bergbahnen => 'Mountain Cable/Railway';

  @override
  String get schifffahrt => 'Shipping';

  @override
  String get lokalbahn => 'Local railway';

  @override
  String get title_filter => 'Filter settings';

  @override
  String get setFilter => 'Activate Filter';

  @override
  String get resetFilter => 'Reset Filter';

  @override
  String get filteracive => 'Filter is active';

  @override
  String get filter_day_active_text => 'Only show locations which are open on the specified day';

  @override
  String get cancel => 'Cancel';

  @override
  String get ok => 'OK';

  @override
  String get disclaimerButtonAgree => 'Agree';

  @override
  String get favorites => 'Favorites';

  @override
  String get sortby => 'Sort by...?';

  @override
  String get name => 'Name';

  @override
  String get dontcare => 'don\'t care';

  @override
  String get must => 'must';

  @override
  String get bookletId => 'Booklet Number';

  @override
  String downloadingTitle(Object year) {
    return 'Downloading data for year $year';
  }

  @override
  String get badWeather => 'Open in bad weather';

  @override
  String get childFriendly => 'Child friendly';

  @override
  String get strollerFriendly => 'Stroller friendly';

  @override
  String get dogAllowed => 'Dogs allowed';

  @override
  String get wheelchairFriendly => 'Wheelchair accessible';

  @override
  String get tavernNear => 'Tavern near';

  @override
  String get groupsAccepted => 'NÖ card accepted for groups';

  @override
  String get openInWinter => 'Open in the winter';

  @override
  String get topLocation => 'Top location';

  @override
  String get notOpenToday => 'Possibly not open today';

  @override
  String possibleNotOpen(String day) {
    return 'Possibly not open on: $day';
  }

  @override
  String yearDisplay(String year1, String year2) {
    return 'Year $year1/$year2';
  }

  @override
  String get map => 'Map';

  @override
  String get readon => 'read on';

  @override
  String get search => 'Search';

  @override
  String get drawerAllLocations => 'All Locations';

  @override
  String get drawerProvinces => 'Provinces';

  @override
  String get drawerFavorits => 'Favorites';

  @override
  String get drawerVisited => 'Visited Locations';

  @override
  String get drawerNear => 'Near Locations';

  @override
  String get drawerSettings => 'Settings';

  @override
  String get settingsDownload => 'Restart app and start download again';

  @override
  String get drawerCards => 'My Cards';

  @override
  String get drawerAbout => 'About';

  @override
  String get settingsTitle => 'Settings';

  @override
  String get noVisited => 'It seems you haven\'t visited any locations yet...\n\nOr maybe you have forgotten to mark a location as visited ✔️ on the detail page?';

  @override
  String get visitedRemoveTitle => 'Delete entry?';

  @override
  String get includedInCard => 'Included in the CARD';

  @override
  String get savings => 'Savings';

  @override
  String get adultCard => 'Adult-CARD';

  @override
  String get childCard => 'Child-CARD';

  @override
  String get noCard => 'There was no saved Card found, please add a Card first.';

  @override
  String get mycardsTitle => 'My Cards';

  @override
  String downloadError(String error) {
    return 'There was an error downloading. Maybe there is no internet-connection?\n\nThe error was: $error';
  }

  @override
  String get visitedScreenTitle => 'Visited';

  @override
  String get systemTheme => 'System Theme';

  @override
  String get lightTheme => 'Light Theme';

  @override
  String get darkTheme => 'Dark Theme';

  @override
  String get regionenScreenTitle => 'Provinces';

  @override
  String get nearScreenTitle => 'Near locations';

  @override
  String positionNotFound(String log) {
    return 'The current position could not be found. Try to activiate the location settings for this app and globaly on this device.\n\n$log';
  }

  @override
  String get textClear => 'Clear';

  @override
  String get openLocationSettings => 'Open Location Settings';

  @override
  String get openAppSettings => 'Open App Settings';

  @override
  String get reqTempFullAcc => 'Request Temporary Full Accuracy';

  @override
  String get getLocAcc => 'Get Location Accuracy';

  @override
  String saveVisitedMessage(String amount, String date) {
    return 'Saved amount € $amount on Date $date';
  }

  @override
  String get detailCall => 'CALL';

  @override
  String get detailMail => 'MAIL';

  @override
  String get detailWeb => 'WEBPAGE';

  @override
  String get detailNav => 'NAVI';

  @override
  String get detailFav => 'FAV';

  @override
  String get disclaimer => 'The developer of this app does not guarantee the completeness and the correctness of the showed data. If you continue to use this app, you confirm that you are aware of this.';

  @override
  String get drawerFinderleinWebsite => 'finderlein.at';

  @override
  String get drawerGithub => 'Contribute on Github';

  @override
  String get drawerLicenses => 'Licenses';

  @override
  String get closeSearch => 'Close Search';

  @override
  String get locationListOnTapHint => 'View Details';

  @override
  String get ttDownloadData => 'Download new data';

  @override
  String get ttChangeSorting => 'Change sort Order';

  @override
  String get ttFilterList => 'Filter the list';

  @override
  String get ttShowLocationsOnMap => 'Show locations on a map';

  @override
  String get checkInWhichDay => 'CheckIn for which day?';

  @override
  String get addAdult => 'Add adult';

  @override
  String get addChild => 'Add child';

  @override
  String get saveCheckin => 'Save';

  @override
  String get checkinSetTo => 'Set to € 0';
}
